// $ANTLR 2.7.2: "AssignExprs.g" -> "AssignExprsRecognizer.java"$

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

import java.io.*;
import java.util.*;

public class AssignExprsRecognizer extends antlr.LLkParser       implements AssignExprsRecognizerTokenTypes
 {

    // Define a main
    public static void main(String[] args) {
        // Use a try/catch block for parser exceptions
        try {
            // if we have at least one command-line argument
            if (args.length > 0 ) {
                System.out.println();
                System.out.println("AssignExprs Parsing...");
                System.out.println();

                // For each directory/file specified on the command line
                for (int i = 0; i < args.length; i++)
                    doFile(new File(args[i]));  // parse it
            } else
                System.out.println("Usage: java AssignExprsRecogizer " +
                                   "[ file | <directory name> ]...");

        } catch (Exception e) {
            System.out.println("Exception: " + e);
            e.printStackTrace(System.out);   // so we can get a stack trace
        }
    }


    // This method decides what action to take based on the
    // type of file we are looking at -- directory or source file
    // It is designed to process a sequence of files/directories
    public static void doFile(File f) throws Exception {
        // If this is a directory, walk each file/dir in that directory
        if (f.isDirectory()) {
            String files[] = f.list();
            for (int i = 0; i < files.length; i++)
                doFile(new File(f, files[i]));        
        // otherwise, if this is a source file, parse it
        } else if ((f.getName().length() >= 5) &&
                   f.getName().substring(f.getName().length()-4).equals(".txt")) {
            //System.out.println("  File: " + f.getAbsolutePath());  //FOO
            System.out.println("  File: " + f.getName());
            parseFile(new FileInputStream(f));
        }
    }

    // Here's where we do the real work...  parse an entire file
    public static void parseFile(InputStream s) throws Exception {
        System.out.println();
        try {
            // Create a scanner that reads from the input stream passed to us
            AssignExprsLexer lexer = new AssignExprsLexer(s);

            // Create a parser that reads from the scanner
            AssignExprsRecognizer parser = new AssignExprsRecognizer(lexer);

            // Start parsing at the program rule
            pSymbols = new TreeMap<String, Symbol>();   // initialize the symbol table
            parser.program();
            System.out.println("* Success *");

        } catch (Exception e) {
            System.out.println("Parser exception: " + e);
            System.out.println();
            e.printStackTrace();   // so we can get a stack trace

        } finally {
            System.out.println();
            if (false) {           // control display of symbol table  //FOO
                displaySymbols();
                System.out.println();
            }
        }
    }

    // An extremely tiny symbol table utility
    // Contains symbol, its type (kind), source line number where last used

    public enum Kind { IDENTIFIER, INTEGER };

    public class Symbol {
        Symbol(String sName, Kind eKind, int nLno) {
            this.sName = sName;  this.eKind = eKind;  this.nLno = nLno;
        }
        public String toString() {
            return "<" + sName + " " + eKind + " " + nLno + ">";
        }
        private String sName;
        private Kind   eKind;
        private int    nLno;
    }

    public static TreeMap<String, Symbol> pSymbols;  // this is the symbol table

    static void displaySymbols() {
        System.out.println("Symbol Table (" + pSymbols.size() + " entries)");
        int n = 1;
        Set set = pSymbols.entrySet();
        for (Iterator i = set.iterator(); i.hasNext(); n++) {
            Map.Entry e = (Map.Entry) i.next();
            String s = ((String)e.getKey()) + "        ";
            System.out.print("   " + (n + "    ").substring(0,3));
            System.out.print("  " + s.substring(0, 8) + " ");
            System.out.println((Symbol)e.getValue());
        }
    }


protected AssignExprsRecognizer(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public AssignExprsRecognizer(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected AssignExprsRecognizer(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public AssignExprsRecognizer(TokenStream lexer) {
  this(lexer,1);
}

public AssignExprsRecognizer(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
}

	public final void program() throws RecognitionException, TokenStreamException {
		
		
		programBody();
	}
	
	public final void programBody() throws RecognitionException, TokenStreamException {
		
		
		match(LITERAL_begin);
		statementList();
		match(LITERAL_end);
	}
	
	public final void statementList() throws RecognitionException, TokenStreamException {
		
		
		switch ( LA(1)) {
		case IDENT:
		{
			statement();
			statementList();
			break;
		}
		case LITERAL_end:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
	}
	
	public final void constantValue() throws RecognitionException, TokenStreamException {
		
		Token  intlit = null;
		
		intlit = LT(1);
		match(INTLIT);
		if ( inputState.guessing==0 ) {
			System.out.println("intlit=" + intlit.getText());    //FOO
			pSymbols.put(intlit.getText(), 
			new Symbol(intlit.getText(), Kind.INTEGER, intlit.getLine()));
			
		}
	}
	
	public final void statement() throws RecognitionException, TokenStreamException {
		
		
		boolean synPredMatched7 = false;
		if (((LA(1)==IDENT))) {
			int _m7 = mark();
			synPredMatched7 = true;
			inputState.guessing++;
			try {
				{
				match(IDENT);
				{
				switch ( LA(1)) {
				case LPAREN:
				{
					match(LPAREN);
					break;
				}
				case SEMI:
				{
					match(SEMI);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				}
			}
			catch (RecognitionException pe) {
				synPredMatched7 = false;
			}
			rewind(_m7);
			inputState.guessing--;
		}
		if ( synPredMatched7 ) {
			procedureCallStatement();
		}
		else if ((LA(1)==IDENT)) {
			assignmentStatement();
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
	}
	
	public final void procedureCallStatement() throws RecognitionException, TokenStreamException {
		
		Token  ident = null;
		
		ident = LT(1);
		match(IDENT);
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			actualParameters();
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(SEMI);
		if ( inputState.guessing==0 ) {
			System.out.println("ident= " + ident.getText());    //FOO
			pSymbols.put(ident.getText(), 
			new Symbol(ident.getText(), Kind.IDENTIFIER, ident.getLine()));
			
		}
	}
	
	public final void assignmentStatement() throws RecognitionException, TokenStreamException {
		
		
		variableReference();
		match(EQUALS);
		expression();
		match(SEMI);
	}
	
	public final void variableReference() throws RecognitionException, TokenStreamException {
		
		Token  ident = null;
		
		ident = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
			System.out.println("ident= " + ident.getText());    //FOO
			pSymbols.put(ident.getText(), 
			new Symbol(ident.getText(), Kind.IDENTIFIER, ident.getLine()));
			
		}
		{
		_loop19:
		do {
			if ((LA(1)==LBRACKET)) {
				match(LBRACKET);
				expression();
				match(RBRACKET);
			}
			else {
				break _loop19;
			}
			
		} while (true);
		}
	}
	
	public final void expression() throws RecognitionException, TokenStreamException {
		
		
		multiplyingExpression();
		{
		_loop34:
		do {
			if ((LA(1)==PLUS||LA(1)==MINUS)) {
				{
				switch ( LA(1)) {
				case PLUS:
				{
					match(PLUS);
					break;
				}
				case MINUS:
				{
					match(MINUS);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				multiplyingExpression();
			}
			else {
				break _loop34;
			}
			
		} while (true);
		}
	}
	
	public final void actualParameters() throws RecognitionException, TokenStreamException {
		
		
		match(LPAREN);
		{
		switch ( LA(1)) {
		case INTLIT:
		case IDENT:
		case LPAREN:
		case PLUS:
		case MINUS:
		{
			expression();
			{
			_loop15:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					expression();
				}
				else {
					break _loop15;
				}
				
			} while (true);
			}
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(RPAREN);
	}
	
	public final void procedureCall() throws RecognitionException, TokenStreamException {
		
		Token  ident = null;
		
		ident = LT(1);
		match(IDENT);
		actualParameters();
		if ( inputState.guessing==0 ) {
			System.out.println("ident= " + ident.getText());    //FOO
			pSymbols.put(ident.getText(), 
			new Symbol(ident.getText(), Kind.IDENTIFIER, ident.getLine()));
			
		}
	}
	
	public final void primitiveElement() throws RecognitionException, TokenStreamException {
		
		
		switch ( LA(1)) {
		case INTLIT:
		{
			constantValue();
			break;
		}
		case LPAREN:
		{
			match(LPAREN);
			expression();
			match(RPAREN);
			break;
		}
		default:
			boolean synPredMatched22 = false;
			if (((LA(1)==IDENT))) {
				int _m22 = mark();
				synPredMatched22 = true;
				inputState.guessing++;
				try {
					{
					match(IDENT);
					match(LPAREN);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched22 = false;
				}
				rewind(_m22);
				inputState.guessing--;
			}
			if ( synPredMatched22 ) {
				procedureCall();
			}
			else if ((LA(1)==IDENT)) {
				variableReference();
			}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
	}
	
	public final void signedExpression() throws RecognitionException, TokenStreamException {
		
		
		{
		_loop26:
		do {
			if ((LA(1)==PLUS||LA(1)==MINUS)) {
				{
				switch ( LA(1)) {
				case PLUS:
				{
					match(PLUS);
					break;
				}
				case MINUS:
				{
					match(MINUS);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
			}
			else {
				break _loop26;
			}
			
		} while (true);
		}
		primitiveElement();
	}
	
	public final void multiplyingExpression() throws RecognitionException, TokenStreamException {
		
		
		signedExpression();
		{
		_loop30:
		do {
			if ((LA(1)==TIMES||LA(1)==DIV)) {
				{
				switch ( LA(1)) {
				case TIMES:
				{
					match(TIMES);
					break;
				}
				case DIV:
				{
					match(DIV);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				signedExpression();
			}
			else {
				break _loop30;
			}
			
		} while (true);
		}
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"begin\"",
		"\"end\"",
		"INTLIT",
		"IDENT",
		"LPAREN",
		"SEMI",
		"EQUALS",
		"COMMA",
		"RPAREN",
		"LBRACKET",
		"RBRACKET",
		"PLUS",
		"MINUS",
		"TIMES",
		"DIV",
		"COMMENT",
		"DIGIT",
		"WS"
	};
	
	
	}
